(*----------------------------------------------------------------------*)
(*          Receive_Ymodem_File --- Download files with Ymodem          *)
(*----------------------------------------------------------------------*)

PROCEDURE Receive_Ymodem_File;

(*----------------------------------------------------------------------*)
(*                                                                      *)
(*     Procedure:  Receive_Ymodem_File                                  *)
(*                                                                      *)
(*     Purpose:    Downloads file to PC using Ymodem batch              *)
(*                                                                      *)
(*     Calling Sequence:                                                *)
(*                                                                      *)
(*        Receive_Ymodem_File;                                          *)
(*                                                                      *)
(*     Calls:   Receive_Xmodem_File                                     *)
(*                                                                      *)
(*----------------------------------------------------------------------*)

VAR
   Local_Save : Saved_Screen_Ptr;

BEGIN (* Receive_Ymodem_File *)

                                   (* Open display window for transfers  *)
   Save_Screen( Local_Save );

   Draw_Menu_Frame( 2, 2, 79, 24, Menu_Frame_Color,
                    Menu_Text_Color,
                    'Batch file download using Ymodem' );

   Writelne( 'Batch file donwload using Ymodem', FALSE );

   Window( 3, 3, 78, 23 );
                                   (* Flags if keyboard halt or    *)
                                   (* null file name encountered   *)
   Stop_Receive   := FALSE;
   Null_File_Name := FALSE;
                                   (* Loop until null file name    *)

   WHILE ( ( NOT Stop_Receive ) AND ( NOT Null_File_Name ) ) DO
      BEGIN
         FileName := '';
         Receive_Xmodem_File( TRUE );
         TextColor( Menu_Text_Color );
         IF ( ( NOT Null_File_Name ) AND ( NOT Stop_Receive ) ) THEN
            Writelne('  Received file: ' + FileName , TRUE );
      END;
                                   (* Acknowledge null file name *)
                                   (* if received                *)
   IF Null_File_Name THEN
      BEGIN
         Writelne(' ', TRUE);
         Writelne('  Received null file name from host.', TRUE);
      END;
                                   (* Indicate end of transfer    *)
   Writelne(' ', TRUE);

   RvsVideoOn ( Menu_Text_Color, BackGround_Color );

   Writelne('  Batch transfer complete.', TRUE);

   RvsVideoOff( Menu_Text_Color, BackGround_Color );

   DELAY( Two_Second_Delay );
                                   (* Remove batch transfer window *)
   Restore_Screen( Local_Save );

   Reset_Global_Colors;

END   (* Receive_Ymodem_File *);
